<?php

/**
 * @file
 * Builds placeholder replacement tokens for order-related data.
 */


/**
 * Implements hook_token_info_alter().
 */
function commerce_webpay_token_info_alter(&$data) {
  $data['tokens']['commerce-order']['voucher-webpay-token'] = array(
    'name' => t('Voucher'),
    'description' => t('Webpay voucher by token') ,
  );
}


/**
 * Implements hook_tokens().
 */
function commerce_webpay_tokens($type, $tokens, array $data = array(), array $options = array()) {
  $replacements = array();

  if ($type == 'commerce-order' && !empty($data['commerce-order'])) {
    $order = $data['commerce-order'];
    foreach ($tokens as $name => $original) {
      switch ($name) {
        // Simple key values on the order.
        case 'voucher-webpay-token':
          $token_ws = isset($order->data['commerce_webpay_token_ws']) ? $order->data['commerce_webpay_token_ws'] : NULL;
          if ($token_ws && ($webpay_transaction = webpay_get_transaction_by_token($token_ws))) {
            $webpay_data_table = commerce_webpay_prepare_voucher($webpay_transaction, $order, TRUE);
            $replacements[$original] = $webpay_data_table;

            break;
          }

          $replacements[$original] = '';

          break;
      }
    }
  }

  return $replacements;
}
